/***************************************************************************
 * COPYRIGHT NOTICE:
 * 
 * Bu projenin kaynak kodlarn size atysam bu aadaki bilgileri
 * deitirebileceiniz anlamna gelmiyor.
 *  
 * Ltfen, emee sayg duyuyorsanz bu dosyaya hi bir ekilde mdahele
 * etmeyin. Yarn bir gn siz de benim gibi byle projeler gelitirip
 * bakasnn sizin yaptnz projeye adn yazmasna nasl katlanamazsanz
 * ayn ekilde ben de katlanamyorum.
 * 
 * UNUTMAYIN: Drstlk kiinin kendisinde balar.
 *  
 ***************************************************************************/

namespace Erle.Controls
{
	using System;
	using System.Web.UI;
	using System.Web.UI.WebControls;

	public class ImageValidator : BaseValidator
	{
		private RegistrationImage regImg;
		private TextBox textBox;
		private String iCtrlID;

		public ImageValidator()	: base() {}
	
		protected override bool EvaluateIsValid()
		{
			String ses = Page.Session[PictureGenerator.KeySecretCode] as String;
			return ((ses != null) && (ses.Length > 0) && (textBox.Text == ses));
		}

		protected override bool ControlPropertiesValid()
		{
			Control c = FindControl(ControlToValidate);
			Control i = FindControl(ImageControlToValidate);

			if ( (null != c) && (null != i) )
			{
				if ((c is TextBox) && (i is RegistrationImage))
				{
					textBox = c as TextBox;
					regImg = i as RegistrationImage;
					return ((null != textBox) && (null != regImg));
				} 
				else
					return false;
			}
			else
				return false;
		}

		public string ImageControlToValidate
		{
			get	{ return iCtrlID; }
			set	{ iCtrlID = value; }
		}
	}
};
